# import json
from asgiref.sync import async_to_sync
from channels.generic.websocket import WebsocketConsumer
from instance.models import Instance
import logging

logger = logging.getLogger(__name__)


class StatusConsumer(WebsocketConsumer):
    def connect(self):
        instances = Instance.objects.all()
        for inst in instances:
            async_to_sync(self.channel_layer.group_add)(
                str(inst.id),
                self.channel_name
            )

    def disconnect(self):
        instances = Instance.objects.all()
        for inst in instances:
            async_to_sync(self.channel_layer.group_discard)(
                str(inst.id),
                self.channel_name
            )

    def receive(self, text_message):
        pass

    def status_changed(self, event):
        logger.info("Event received")
        self.send(text_data=event["status"])
